\section{Use case 2 : communication-avoiding Cholesky factorization}
\label{sec:scal_chol}

\begin{ab}
  qq part dans cette section il faut ecrire l'algo sequentiel aussi
  pour definir les noyaux qui sont utilisés plus bas
\end{ab}

The Cholesky factorization is a very well known linear algebra
operation which is widely used in many applications in scientific
computing and data analytics. For this reason it has been the object
of the numerous studies that aim at improving its efficiency and
scalability on parallel supercomputers; these include some recent
efforts around the used of task-based parallelism and
runtimes~\cite{a.a.f.f.ea:17,d.j.s.t:20}.

The use of 3D logical grids to compute distributed-memory matrix
factorization has been the subject of recent
studies~\cite{s.d:11,k.k.b.z:21,b.d.e.l.v:22}. Their authors have designed
algorithms to make this operation more scalable with a common focus on
minimizing the communication volume and number. %amount of data exchanged between processes.
%%Such grids indeed defy
%%the design of this operation vastly more than \GEMM.
%When factorizing,
%different tasks are involved. First each block goes through one or multiple chains
%of (commutative) updates that are possibly assembled.
%%-- this is a similar
%%behavior to \GEMM.
%However then the block is either solved or factorized before being
%broadcast: such a behavior creates more dependencies in the DAG of the operation.
%In order to account for the dependencies created by assigning updates across layers --
%a common design choice in the literature -- the input matrix is not stored
%through the standard 2DBC layout but rather on more complex layouts that involve
%all layers of the 3D ranks grid.
%Additional design choices have been proposed in the last decade. These
%choices have however often been restricted to their respective designers'
%implementations and have hardly if ever been adopted in common software packages. In
%this section, we aim at leveraging the extended STF programming model in order
%to bring the complementary designs of the 3D Cholesky factorization under a single portable code.

We first present the algorithms we want to adapt in Section~\ref{sec:back.chol}.
Then we adapt the algorithm from \citeauthor{b.d.e.l.v:22}~\cite{b.d.e.l.v:22}
to our extended set of features in Section~\ref{sec:chol.naive}. Through the
features designed in Section~\ref{sec:repl}, the LU factorization from
\citeauthor{s.d:11}~\cite{s.d:11} is adapted to the symmetric case in
Section~\ref{sec:repl.solv.chol.repl}.
%Section~\ref{sec:repl.solv.chol.part}
%then consider the design proposed by \citeauthor{k.k.b.z:21}~\cite{k.k.b.z:21}.
The final STF implementation is parameterized to set up the complementary
designs: Section~\ref{sec:repl.allreduce.exp}
evaluates the performance of two variants of the Cholesky factorization we
implemented as well as state-of-the-art ConFLUX package~\cite{k.k.b.z:21}.

\subsection{Scalable matrix factorization algorithms}
\label{sec:back.chol}

%LAPACK standardizes multiple routines to factorize
%matrices~\cite{a.b.b.b.ea:99}. These routines implement algorithms
%that take the properties of the matrices into consideration. In the
%case of factorization resulting in triangular matrices, two principal
%implementations are \GETRF which outputs the $LU$
%factorization of an input matrix $A$ of any size and \POTRF
%which outputs the $LL^T$ factorization of a symmetric positive
%definite matrix $A$.  If not for numerical stability considerations
%that lead to pivoting in \GETRF, both algorithms execute
%similarly: as they iterate over the columns of $A$, they factor the
%diagonal element $a_{ii}$, scale the elements below the diagonal using
%$u_{ii}$ or $l_{ii}$ and update the trailing submatrix through a
%rank-one update using the vector $l_{i,i+1:}$~-- as well as
%$u_{i+1:,i}$ if $A$ is not symmetric. A partially factorized matrix is
%presented in the left of Figure~\ref{fig:getrf.elem2tile}.
%
%The same three steps described above are also found in blocked
%variants of the factorization algorithms. At each step, instead of
%factorizing the element $a_{ii}$, an entire diagonal block of $A$ is
%factorized using \GETRF or \POTRF.  All the
%off-diagonal blocks are then solved with respect to $U_{ii}$ -- or
%$L_{ii}^T$ -- through the \trsm subprogram. Given square
%blocks of size $b$, updating the remainder of the matrix is equivalent
%to a rank-$b$ update using \gemm~-- or \syrk if $A$ is
%symmetric~-- with off-diagonal blocks (see Algorithm 1 from
%\citeauthor{b.l.k.d:09}\cite{b.l.k.d:09}). A partially factorized,
%blocked matrix is presented in the right of
%Figure~\ref{fig:getrf.elem2tile}.
%
%\begin{figure}[h]
%	\centering
%	\begin{subfigure}{0.47\textwidth}
%	\centering
%	\begin{tikzpicture}[scale=0.3]
%		\pgfmathsetmacro{\l}{4}
%		\pgfmathsetmacro{\b}{2}
%		\pgfmathsetmacro{\m}{int(\b*5)}
%		\pgfmathsetmacro{\n}{\m}
%
%		\fill[myred!30] (0,0) rectangle ++(\n,\m);
%		\fill[myred] (\l,\m-\l-1) rectangle ++(1,1);
%		\fill[mypur!60] (\l+1,\m-\l-1) rectangle ++(\n-\l-1,1);
%		\fill[mygre] (\l,0) rectangle ++(1,\m-\l-1);
%		\fill[myblu] (\l+1,0) rectangle ++(\n-\l-1,\m-\l-1);
%
%		\draw[step=1,gray!90,thick] (0,0) grid ++(\n,\m);
%%		\draw[step=\b,dashed,black,thick] (0,0) grid ++(\n,\m);
%
%		\fill[mypur] (0,0) -- ++(0,\m) -- ++(\n,0) -- ++(0,-\l) -- ++(\l-\n,0) -- ++(0,\l-\m) -- cycle;
%		\fill[myorg] (0,0) -- ++(0,\m) -- ++(\l,-\l) -- ++(0,\l-\m) -- cycle;
%	\end{tikzpicture}
%	\label{fig:getrf.elem2tile.elem}
%	\end{subfigure}
%	\begin{subfigure}{0.47\textwidth}
%	\centering
%	\begin{tikzpicture}[scale=0.3]
%		\pgfmathsetmacro{\l}{4}
%		\pgfmathsetmacro{\b}{2}
%		\pgfmathsetmacro{\m}{int(\b*5)}
%		\pgfmathsetmacro{\n}{\m}
%
%		\fill[myred!30] (0,0) rectangle ++(\n,\m);
%		\fill[myred] (\l,\m-\l-\b) rectangle ++(\b,\b);
%		\fill[mygre] (\l+\b,\m-\l-\b) rectangle ++(\n-\l-\b,\b);
%		\fill[mygre] (\l,0) rectangle ++(\b,\m-\l-\b);
%		\fill[myblu] (\l+\b,0) rectangle ++(\n-\l-\b,\m-\l-\b);
%
%		\draw[step=1,gray!90,thick] (0,0) grid ++(\n,\m);
%		\draw[step=\b,dashed,black,thick] (0,0) grid ++(\n,\m);
%
%		\fill[mypur] (0,0) -- ++(0,\m) -- ++(\n,0) -- ++(0,-\l) -- ++(\l-\n,0) -- ++(0,\l-\m) -- cycle;
%		\fill[myorg] (0,0) -- ++(0,\m) -- ++(\l,-\l) -- ++(0,\l-\m) -- cycle;
%	\end{tikzpicture}
%	\label{fig:getrf.elem2tile.tile}
%	\end{subfigure}
%	\caption[\texttt{GETRF} algorithm at a given step.]
%	{ \texttt{GETRF} algorithm at a given step where the orange
%          panel is the factorized $L$ matrix, the purple panel is the
%          factorized $U$ matrix, the red element (resp. blocks)
%          corresponds to the factorization step, the green elements
%          (resp. blocks) correspond to the solve step and the blue
%          elements (resp. blocks) correspond to the update
%          step. \textbf{Left:} Element-wise factorization.
%          \textbf{Right:} Block-wise factorization.  }
%	\label{fig:getrf.elem2tile}
%\end{figure}

%As explained above, in a distributed-memory setting an important
%design choice concerns the workload distribution. In the case of
%factorization algorithms, this assignment can be visualized as a 3D
%lattice where the element $(i,j,l)$ corresponds to the processing of
%the block $A_{ij}$ at the $l^{\text{th}}$ step of the
%factorization. If $l > max(i,j)$, the $A_{ij}$ block has already been
%factorized. Figure~\ref{fig:getrf.computemap} illustrates the case of
%the LU factorization where blocks of color correspond to an operation
%executed over a block of the input matrix.  While this representation
%can guide programmers to extract parallelism when designing software,
%it fails to account for existing dependencies in the operation: a
%block can be factorized (or solved) if and only if it has been updated
%with respect to all previous iterations.
%A pseudocode for the
%right-looking distributed-memory Cholesky factorization is provided in
%Figure~\ref{alg:back.potrf}. In this algorithm, updates are
%executed as early as possible to benefit from high
%parallelism. Updates can also be deferred as late as possible which
%lead to the left-looking variant of the $LL^T$ factorization.

%\begin{figure}
%	\centering
%	\begin{tikzpicture}[scale=0.4]
%		\pgfmathsetmacro{\m}{6}
%		\pgfmathsetmacro{\n}{6}
%		\pgfmathsetmacro{\x}{0}
%		\pgfmathsetmacro{\y}{0}
%		\pgfmathsetmacro{\t}{15} % degrees
%
%		\foreach \l in {1,2,...,\m}{
%			\pgfmathsetmacro{\g}{50+30*(\l/\m)} % grayscale
%			\pgfmathsetmacro{\gM}{\g+10}
%			\pgfmathsetmacro{\gm}{\g-10}
%			\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%			\pgfmathsetmacro{\y}{\l*1.2}
%
%			\fill[myred!\g] ($ (\x,\y) + (0,1) $) -- ++(-\t:1) -- ++(0,-1) -- ++(180-\t:1) --  cycle;
%			\fill[myred!\gM] ($ (\x,\y) + (0,1) $) -- ++(\t:1) -- ++(-\t:1) -- ++(\t-180:1) --  cycle;
%			\ifthenelse{\l=\m}{
%				\fill[myred!\gm] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) --  cycle;
%			}{
%				\fill[mygre!\gM] ($ (\x,\y) + (-\t:1) + (0,1) $) -- ++(\t:1) -- ++(-\t:\m-\l) -- ++(\t-180:1) -- cycle;
%				\fill[mygre!\g ] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(-\t:\m-\l) -- ++(0,-1) -- cycle;
%				\fill[mygre!\gm] ($ (\x,\y) + (-\t:\m-\l+1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) -- cycle; %++(-\t:\m-\l) -- ++(0,-1) -- ++(\t-180:1) -- cycle;
%			}
%			\fill[myblu!\gM] ($ (\x,\y) + (0,1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:1) -- ++(\t-180:\n-\l) -- cycle;
%			\fill[gray!\gM] ($ (\x,\y) + (0,1) + (-\t:1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:\m-\l) -- ++(\t-180:\n-\l) -- cycle;
%			\fill[gray!\g] ($ (\x,\y) + (-\t:\m-\l+1) + (\t:1) $) -- ++(0,1) -- ++(\t:\n-\l) -- ++(0,-1) -- cycle;
%		}
%		\pgfmathsetmacro{\l}{3}
%		\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%		\pgfmathsetmacro{\y}{\l*1.2}
%		\node[] (trf) at ($(\x,\y)+(-1,3.5)$)
%{\texttt{getrf}($A_{\l\l}$)};
%		\draw[black,-latex] (trf.south) .. controls ++(0,-1) .. ($(\x,\y)+(0,1)$);
%
%		\pgfmathsetmacro{\l}{2}
%		\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%		\pgfmathsetmacro{\y}{\l*1.2}
%		\node[] (trsm) at ($(\x,\y)+(\t:1)+(-\t:\m-\l)+(7,-2)$)
%{\texttt{trsm}($A_{\l:}$ w.r.t $U_{\l\l}$)};
%		\draw[black,-latex] (trsm.west) .. controls ++(-1.5,0.5) .. ($(\x,\y)+(\t:1)+(-\t:\m-\l)+(0.5,-0.2)$);
%
%		\pgfmathsetmacro{\l}{4}
%		\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%		\pgfmathsetmacro{\y}{\l*1.2}
%		\node[] (gemm) at ($(\x,\y)+(13.5,0)$) {\texttt{gemm}($A_{::}$
%w.r.t $L_{\l:}$ and $U_{:\l}$)};
%		\draw[black,-latex] (gemm.west) .. controls ++(-1,-0.25) .. ($(\x,\y)+(\t:3)+(-\t:3)$);
%	\end{tikzpicture}
%	\caption[3D visualization for factorization algorithms]{
%		Visualization of the elementary block operations involved in the
%		LU factorization. Red blocks correspond to \texttt{getrf} tasks
%		applied on diagonal blocks, blue and green tasks are
%		\texttt{trsm} tasks applied off the diagonal, and grey tasks
%		correspond to update tasks.
%	}
%	\label{fig:getrf.computemap}
%\end{figure}

%\begin{figure}
%\begin{algorithmic}[1]
%  \FOR{$l = 1\dots m$}
%    \IF{l\%q = c}
%      \STATE \textbf{if} $l\%p = r$ \textbf{then} call \potrf($A_{ll}$)
%      \STATE bcast($A_{ll}$,to:($:,c$))\;
%    \ENDIF
%    \FORALL{$i=l+1\dots m$ such that $i\%p=r$}
%      \STATE \textbf{if} $l\%q = c$ \textbf{then} call \trsm($A_{ll}$,$A_{il}$)
%      \STATE bcast($A_{il}$,to:($r,:$))\;
%      \STATE bcast($A_{il}$,to:($:,c$))\;
%    \ENDFOR
%    \FORALL{$i = l+1\dots m$ such that $i\%p=r$}
%	\STATE \textbf{if} $i\%q=c$ \textbf{then} call \syrk($A_{il}$,$A_{ij}$)
%      \FORALL{$j= i+1\dots m$ such that $j\%q=c$}
%	\STATE \textbf{if} $i\%q=c$ \textbf{then} call \gemm($A_{il}$,$A_{jl}$,$A_{ij}$)
%      \ENDFOR
%    \ENDFOR
%  \ENDFOR
%\end{algorithmic}
%  \caption[Right-Looking 2DBC Cholesky Factorization]
%	{Right-looking 2DBC Cholesky factorization of a matrix $A$ by blocks for a rank $(r,c)$.}
%  \label{alg:back.potrf}
%\end{figure}
\begin{ab}
  je ne dirais pas que notre implementation repose sur la distribution
  2DBC; au contraire on devrait montrer qu'elle est distribution-agnostic
\end{ab}
The presented Cholesky decomposition relies on the 2D Block-Cyclic layout. Because
there are plenty of independent statements through \trsm
and \gemm calls, it is possible to obtain relatively good performance
with this algorithm: each rank is involved in most steps to execute multiple
block-wise operations.
% Nonetheless this distribution is not the most efficient
% to tackle the operation. First, it is important to use the symmetric property of
% the matrix in an advantageous way~\cite{b.d.e.l.v:22}. Then
%, as for
%Matrix-Matrix multiplications presented in Section~\ref{sec:distr-memory-scal},
3D logical grids of ranks can be operated to further reduce the communication
volume~\cite{i.t:02}.
%The case of pivoting for numerical stability in \texttt{GETRF} can be addressed
%with scalable mechanisms such as tournament pivoting that delivers numerical
%stability in practice~\cite{s.d:11}.

\begin{ab}
  on ne devrait pas parler des distributions symmetriques dans cet
  article. c'est completement orthogonale et ca noie le message
\end{ab}
3D Cholesky factorization algorithms have often been implemented through the
standard MPI+X programming
model: it is possible to ease the design of factorization algorithms through the
use of runtime systems. This approach enables the use of specific layouts to
further enhance scalability
%~-- this has been shown with symmetric layouts for
%\POTRF by \citeauthor{b.d.e.l.v:22}
~\cite{b.d.e.l.v:22}. Such symmetric layouts can be stacked into layers.
In their 3D algorithm, \citeauthor{b.d.e.l.v:22} assigned each step of the Cholesky
factorization to a single layer with the matrix distributed accordingly.
%and they distributed the matrix accordingly.
%This round-robin storage and assignment of tasks is depicted in the right of
%Figure~\ref{fig:back.facto.algs}.

\citeauthor{s.d:11} assign the updates in the same
fashion~\cite{s.d:11}.
%related to the
%$l^{th}$ iteration to the $(l\%h)^{th}$ layer -- assuming there are $h$ layers
%in the 3D grid~\cite{s.d:11}.
%The first benefit of using a 3D logical grid comes
%with a reduction in communication volume. Similarly to matrix-matrix
%multiplication when broadcasts are executed by rows or columns of processes,
%the 3D logical grid of dimension
%$\sqrt{\sfrac{P}{h}}\times\sqrt{\sfrac{P}{h}}\times h$ ranks
%incurs fewer data movements than the 2D logical grid of $\sqrt{P}\times\sqrt{P}$
%ranks. The second benefit comes with an increased parallelism by assigning more
%ranks to the computation of \texttt{trsm}.
In their algorithm, \citeauthor{s.d:11} chose to replicate
the computation of diagonal block factorization over layers \emph{i.e.} over an
aisle of $h$ ranks to be able to distribute their \texttt{trsm}s over columns of
ranks across layers.
The authors' algorithm result in an increase in parallelism when
executing \texttt{trsm}s that is expected to ease the allocation of resources
over the critical path.
%By doing so,
%they are also able to bypass some steps required to broadcast the factorized,
%assembled diagonal block: each $h$ rank is responsible to broadcast the
%replicated block
%inside its layer.
The authors therefore propose a hierarchical cyclic distribution of the matrix
$A$ into ``big blocks'' owned by ranks in the same layer and ``small blocks''
owned by a single rank.
%The authors' design is sensible if each block-column
%and/or block-row of the matrix $A$ is stored over several layers: the hierarchy
%of their layout verifies this property.
%Their mapping of
%tasks is depicted in the left of Figure~\ref{fig:back.facto.algs}.
%The initial interest
%of the authors was LU factorization: their work has been extended to Cholesky
%Factorization through UPC~\cite{g.g.s.z:12}. The case of sparse Cholesky
%factorization has also been considered~\cite{j.z.n.y:16}.

%A pseudocode for the 3D \POTRF of \citeauthor{s.d:11} is proposed in
%Figure~\ref{alg:back.potrf3D}. Note that this pseudocode leaves room to
%choose the distribution of the matrix $A$. It assumes that the diagonal block is
%factorized over multiple ranks. The symmetry is not strictly taken into account
%in this pseudocode as results of \trsm are systematically broadcasts to
%$(r,:,h)$ and $(:,c,h)$. For the sake of simplicity the edge cases
%occurring when a block-row of block-column is stored over a single communicator are
%discarded and two broadcasts are submitted.
%
%\begin{figure}
%\begin{algorithmic}[1]
%  \FOR{$l = 1\dots m$}
%    \IF{l\%q = c}
%      \IF{l\%p = r}
%	\STATE all\_reduce($A_{ll}$,across:($r,c,:$))\label{code:3d.potrf.allreduce}\;
%	\STATE call \potrf($A_{ll}$)
%      \ENDIF
%      \STATE bcast($A_{ll}$,to:($:,c,h$))\label{code:3d.potrf.layer-bcast}\;
%    \ENDIF
%    \FORALL{$i=l+1\dots m$ such that $i\%p=r$}
%      \IF{l\%q = c}
%	\STATE reduce($A_{il}$,across:($r,c,:$))\label{code:3d.potrf.reduce}\;
%        \STATE H $\gets$ layer of big block storing $A_{il}$\;
%	\STATE \textbf{if $h=H$} call \trsm($A_{ll}$,$A_{il}$)\;
%        \STATE bcast($A_{il}$,to:($r,:,h$))\label{code:3d.potrf.bcast}\;
%        \STATE bcast($A_{il}$,to:($:,c,h$))\;
%      \ENDIF
%    \ENDFOR
%    \STATE H $\gets$ l \% h\;
%    \IF{h=H}
%      \FORALL{$i = l+1\dots m$ such that $i\%p=r$}
%	\STATE \textbf{if} $i\%q=c$ \textbf{then} call \syrk($A_{il}$,$A_{ij}$)
%        \FORALL{$j= i+1\dots m$ such that $j\%q=c$}
%	  \STATE \textbf{if} $i\%q=c$ \textbf{then} call \gemm($A_{il}$,$A_{jl}$,$A_{ij}$)
%	\ENDFOR
%      \ENDFOR
%    \ENDIF
%  \ENDFOR
%\end{algorithmic}
%  \caption[Right-Looking 3D Cholesky Factorization]
%	{Right-looking 3D Cholesky factorization of a matrix $A$ by blocks for a rank $(r,c,h)$.}
%  \label{alg:back.potrf3D}
%\end{figure}

%In SUMMA algorithms, all the outer products can be readily mapped to any layer
%available in the 3D grid. This property comes from the embarrassingly parallel
%nature of the matrix-matrix multiplication. For factorization algorithms the
%dependencies are much stronger and hinder parallelism: the updates in the
%trailing submatrix of a given step depend on the terminal tasks (factor,solve) of this step.
%Therefore update tasks are accumulated iteratively across layers. To increase
%parallelism, \citeauthor{k.k.b.z:21} propose to break down the rank-$b$ update operation in $h$ updates of rank
%$\sfrac{b}{h}$~\cite{k.k.b.z:21}. The resulting mapping of tasks from the
%algorithm they propose is depicted in the center of Figure~\ref{fig:back.facto.algs}.
%They essentially ensure that all layers are taking part in the bulk of
%computation -- the update phase -- as early as possible in the operation. By
%doing so, assuming a strictly synchronous setting, fewer ranks are left idle.
%Note that in the material of their experiments, \citeauthor{k.k.b.z:21}
%rely on 2 layers at most.

%\begin{figure}
%	\centering
%	\begin{subfigure}{0.32\textwidth}
%		\centering
%		\begin{tikzpicture}[scale=0.3]
%			\pgfmathsetmacro{\m}{6}
%			\pgfmathsetmacro{\n}{6}
%			\pgfmathsetmacro{\x}{0}
%			\pgfmathsetmacro{\y}{0}
%			\pgfmathsetmacro{\t}{15} % degrees
%
%			\foreach \l in {1,2,...,\m}{
%				\pgfmathsetmacro{\g}{50+30*(\l/\m)} % grayscale
%				\pgfmathsetmacro{\gM}{\g+10}
%				\pgfmathsetmacro{\gm}{\g-10}
%				\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%				\pgfmathsetmacro{\y}{\l*1.2}
%				\pgfmathsetmacro{\h}{3}
%
%				\pgfmathsetmacro{\lyr}{int(Mod(\l,\h))}
%				\ifthenelse{\lyr=0}{
%					\def\colr{myyel}
%				}{
%				\ifthenelse{\lyr=1}{
%					\def\colr{myorg}
%				}{
%				\ifthenelse{\lyr=2}{
%					\def\colr{mypur}
%				}{}}}
%				\pgfmathsetmacro{\Lyr}{int( Mod( int((\l-1)/(\m/\h)), \h ) )}
%				\ifthenelse{\Lyr=0}{
%					\def\Colr{myyel}
%				}{
%				\ifthenelse{\Lyr=1}{
%					\def\Colr{myorg}
%				}{
%				\ifthenelse{\Lyr=2}{
%					\def\Colr{mypur}
%				}{}}}
%
%				% DIAG
%				\fill[opacity=0.8,\Colr!\g!black] ($ (\x,\y) + (0,1) $) -- ++(-\t:1) -- ++(0,-1) -- ++(180-\t:1) --  cycle;
%				\fill[opacity=0.8,\Colr!\gM!black] ($ (\x,\y) + (0,1) $) -- ++(\t:1) -- ++(-\t:1) -- ++(\t-180:1) --  cycle;
%				\fill[opacity=0.8,\Colr!\gm!black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) --  cycle;
%				% BACK
%				\fill[opacity=0.8,\Colr!\g!black] ($ (\x,\y) + (-\t:1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(0,1) -- ++(\t-180:\n-\l) -- cycle;
%				\fill[opacity=0.8,\Colr!\gM!black] ($ (\x,\y) + (0,1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:1) -- ++(\t-180:\n-\l) -- cycle;
%				% UPDATE
%				\fill[\colr!\gM] ($ (\x,\y) + (0,1) + (-\t:1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:\m-\l) -- ++(\t-180:\n-\l) -- cycle;
%				\fill[\colr!\g ] ($ (\x,\y) + (-\t:\m-\l+1) + (\t:1) $) -- ++(0,1) -- ++(\t:\n-\l) -- ++(0,-1) -- cycle;
%				\fill[\colr!\gm] ($ (\x,\y) + (-\t:1) + (\t:1) $) -- ++(-\t:\n-\l) -- ++(0,1) -- ++(180-\t:\n-\l) -- cycle;
%				% FRONT
%				\ifthenelse{\l=\m}{}{
%					\pgfmathsetmacro{\mmm}{\m-\l}
%					\pgfmathsetmacro{\xpp}{\x+1}
%					\foreach \mit in {1,...,\mmm}{%mx [evaluate=\mx as \my using (\y+\mx-\x)] in {\x, \xpp, ..., \mmm}{
%						\pgfmathsetmacro{\Lyr}{int( Mod( int((\l+\mit-1)/(\m/\h)), \h ) )}
%						\ifthenelse{\Lyr=0}{
%							\def\Colr{myyel}
%						}{
%						\ifthenelse{\Lyr=1}{
%							\def\Colr{myorg}
%						}{
%						\ifthenelse{\Lyr=2}{
%							\def\Colr{mypur}
%						}{}}}
%						\fill[opacity=0.8,\Colr!\gM!black] ($ (\x,\y) + (-\t:\mit) + (0,1) $) -- ++(\t:1) -- ++(-\t:1) -- ++(\t-180:1) -- cycle;
%						\fill[opacity=0.8,\Colr!\g !black] ($ (\x,\y) + (-\t:\mit) $) -- ++(0,1) -- ++(-\t:1) -- ++(0,-1) -- cycle;
%					}
%					\pgfmathsetmacro{\Lyr}{int( Mod( int((\m-1)/(\m/\h)), \h ) )}
%					\ifthenelse{\Lyr=0}{
%						\def\Colr{myyel}
%					}{
%					\ifthenelse{\Lyr=1}{
%						\def\Colr{myorg}
%					}{
%					\ifthenelse{\Lyr=2}{
%						\def\Colr{mypur}
%					}{}}}
%					\fill[opacity=0.8,\Colr!\gm!black] ($ (\x,\y) + (-\t:\m-\l+1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) -- cycle; %++(-\t:\m-\l) -- ++(0,-1) -- ++(\t-180:1) -- cycle;
%					%\fill[opacity=0.8,\Colr!\gM!black] ($ (\x,\y) + (-\t:1) + (0,1) $) -- ++(\t:1) -- ++(-\t:\m-\l) -- ++(\t-180:1) -- cycle;
%					%\fill[opacity=0.8,\Colr!\g !black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(-\t:\m-\l) -- ++(0,-1) -- cycle;
%					%\fill[opacity=0.8,\Colr!\gm!black] ($ (\x,\y) + (-\t:\m-\l+1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) -- cycle; %++(-\t:\m-\l) -- ++(0,-1) -- ++(\t-180:1) -- cycle;
%				}
%			}
%		\end{tikzpicture}
%		\label{fig:back.trf.solomonik}
%	\end{subfigure}
%	\begin{subfigure}{0.32\textwidth}
%		\centering
%		\begin{tikzpicture}[scale=0.3]
%			\pgfmathsetmacro{\m}{6}
%			\pgfmathsetmacro{\n}{6}
%			\pgfmathsetmacro{\x}{0}
%			\pgfmathsetmacro{\y}{0}
%			\pgfmathsetmacro{\t}{15} % degrees
%
%			\foreach \l in {1,2,...,\m}{
%				\pgfmathsetmacro{\g}{50+30*(\l/\m)} % grayscale
%				\pgfmathsetmacro{\gM}{\g+10}
%				\pgfmathsetmacro{\gm}{\g-10}
%				\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%				\pgfmathsetmacro{\y}{\l*1.2}
%				\pgfmathsetmacro{\h}{3}
%
%				\fill[opacity=0.8,myred!\g!black] ($ (\x,\y) + (0,1) $) -- ++(-\t:1) -- ++(0,-1) -- ++(180-\t:1) --  cycle;
%				\fill[opacity=0.8,myred!\gM!black] ($ (\x,\y) + (0,1) $) -- ++(\t:1) -- ++(-\t:1) -- ++(\t-180:1) --  cycle;
%				\fill[opacity=0.8,myred!\gm!black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) --  cycle;
%
%				\fill[opacity=0.8,myred!\g!black] ($ (\x,\y) + (-\t:1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(0,1) -- ++(\t-180:\n-\l) -- cycle;
%				\fill[opacity=0.8,myred!\gM!black] ($ (\x,\y) + (0,1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:1) -- ++(\t-180:\n-\l) -- cycle;
%
%				\foreach \lyr in {0,1,2}{
%					\ifthenelse{\lyr=0}{
%						\def\colr{myyel}
%					}{
%					\ifthenelse{\lyr=1}{
%						\def\colr{myorg}
%					}{
%					\ifthenelse{\lyr=2}{
%						\def\colr{mypur}
%					}{}}}
%					\fill[\colr!\gM] ($ (\x,\y) + (0,1) + (-\t:1) + (\t:1) $) -- ++(\t:\n-\l) -- ++(-\t:\m-\l) -- ++(\t-180:\n-\l) -- cycle;
%					\fill[\colr!\g ] ($ (\x,\y) + (-\t:\m-\l+1) + (\t:1) + (0,\lyr/\h)$) -- ++(0,1/\h) -- ++(\t:\n-\l) -- ++(0,-1/\h) -- cycle;
%					\fill[\colr!\gm] ($ (\x,\y) + (-\t:1) + (\t:1) + (0,\lyr/\h) $) -- ++(-\t:\n-\l) -- ++(0,1/\h) -- ++(180-\t:\n-\l) -- cycle;
%				}
%
%
%				\ifthenelse{\l=\m}{}{
%					\fill[opacity=0.8,myred!\gM!black] ($ (\x,\y) + (-\t:1) + (0,1) $) -- ++(\t:1) -- ++(-\t:\m-\l) -- ++(\t-180:1) -- cycle;
%					\fill[opacity=0.8,myred!\g !black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(-\t:\m-\l) -- ++(0,-1) -- cycle;
%					\fill[opacity=0.8,myred!\gm!black] ($ (\x,\y) + (-\t:\m-\l+1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) -- cycle; %++(-\t:\m-\l) -- ++(0,-1) -- ++(\t-180:1) -- cycle;
%				}
%			}
%		\end{tikzpicture}
%		\label{fig:back.trf.kwasniewski}
%	\end{subfigure}
%	\begin{subfigure}{0.32\textwidth}
%		\centering
%		\begin{tikzpicture}[scale=0.3]
%			\pgfmathsetmacro{\m}{6}
%			\pgfmathsetmacro{\n}{6}
%			\pgfmathsetmacro{\x}{0}
%			\pgfmathsetmacro{\y}{0}
%			\pgfmathsetmacro{\t}{15} % degrees
%
%			\foreach \l in {1,2,...,\m}{
%				\pgfmathsetmacro{\g}{50+30*(\l/\m)} % grayscale
%				\pgfmathsetmacro{\gM}{\g+10}
%				\pgfmathsetmacro{\gm}{\g-10}
%				\pgfmathsetmacro{\x}{\l*2*cos(\t)}
%				\pgfmathsetmacro{\y}{\l*1.2}
%				\pgfmathsetmacro{\h}{3}
%
%				\pgfmathsetmacro{\lyr}{int(Mod(\l,\h))}
%				\def\colr{myyel}
%				\ifthenelse{\lyr=0}{
%					\def\colr{myyel}
%				}{
%				\ifthenelse{\lyr=1}{
%					\def\colr{myorg}
%				}{
%				\ifthenelse{\lyr=2}{
%					\def\colr{mypur}
%				}{}}}
%
%				\fill[opacity=0.8,\colr!\g!black] ($ (\x,\y) + (0,1) $) -- ++(-\t:1) -- ++(0,-1) -- ++(180-\t:1) --  cycle;
%				\fill[opacity=0.8,\colr!\gM!black] ($ (\x,\y) + (0,1) $) -- ++($(\t:1)+(-\t:1)$) -- ++(\t-180:1) --  cycle;
%				\fill[opacity=0.8,\colr!\gm!black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) --  cycle;
%
%				\fill[\colr!\gM] ($ (\x,\y) + (0,1) + (-\t:1) + (\t:1) $) -- ++($(\t:\n-\l)+(-\t:\m-\l)$) -- ++(\t-180:\n-\l) -- cycle;
%				\fill[\colr!\g ] ($ (\x,\y) + (-\t:\m-\l+1) + (\t:1) $) -- ++(0,1) -- ++(\t:\n-\l) -- ++(0,-1) -- cycle;
%				\fill[\colr!\gm] ($ (\x,\y) + (-\t:1) + (\t:1) $) -- ++(-\t:\n-\l) -- ++(0,1) -- ++(180-\t:\n-\l) -- cycle;
%
%				\ifthenelse{\l=\m}{}{
%					\fill[opacity=0.8,\colr!\gM!black] ($ (\x,\y) + (-\t:1) + (0,1) $) -- ++(\t:1) -- ++(-\t:\m-\l) -- ++(\t-180:1) -- cycle;
%					\fill[opacity=0.8,\colr!\g !black] ($ (\x,\y) + (-\t:1) $) -- ++(0,1) -- ++(-\t:\m-\l) -- ++(0,-1) -- cycle;
%					\fill[opacity=0.8,\colr!\gm!black] ($ (\x,\y) + (-\t:\m-\l+1) $) -- ++(0,1) -- ++(\t:1) -- ++(0,-1) -- cycle; %++(-\t:\m-\l) -- ++(0,-1) -- ++(\t-180:1) -- cycle;
%				}
%			}
%		\end{tikzpicture}
%		\label{fig:back.trf.beaumont}
%	\end{subfigure}
%	\caption[Maps for state-of-the-art factorization algorithms]
%	{
%		State-of-the-art factorization algorithms map tasks onto
%		processes differently. Three layers are represented with three
%		colors (purple, orange, yellow). \textbf{Left:}
%		\citeauthor{s.d:11} assign updates in a round-robin
%		fashion over layers and distribute the matrix
%		hierarchically. \textbf{Center:} \citeauthor{k.k.b.z:21}
%		partition updates over layers so all layers are involved at each
%		iteration. \textbf{Right:} \citeauthor{b.d.e.l.v:22} assign each
%		iteration, both factorization and update, to a layer.
%	}
%	\label{fig:back.facto.algs}
%\end{figure}

\subsubsection{3D update approach}
\label{sec:chol.naive}

% % % % % % % % % % % % % % Throughout an LU or Cholesky factorization, the trailing submatrix
% % % % % % % % % % % % % % receives multiple contributions in the form of rank-k updates which
% % % % % % % % % % % % % % are commutative and associative.
% % % % % % % % % % % % % % %As in the case of the \GEMM operation
% % % % % % % % % % % % % % %described in Chapter~\ref{sec:stf-matrix-multiply},
% % % % % % % % % % % % % % These properties
% % % % % % % % % % % % % % can be easily exploited to design 3D algorithms: the computation of
% % % % % % % % % % % % % % successive updates can be assigned to different layers in a 3D ranks
% % % % % % % % % % % % % % grid and assembled using reduction operations prior to an factorization
% % % % % % % % % % % % % % operation. This idea, which reduces the communication volume of the
% % % % % % % % % % % % % % factorization, has already been used by \citeauthor{b.d.e.l.v:22} in a
% % % % % % % % % % % % % % recent work whose main objective is the design of a data distribution
% % % % % % % % % % % % % % specifically suited for symmetric matrices and
% % % % % % % % % % % % % % algorithms~\cite{b.d.e.l.v:22}.
% % % % % % % % % % % % % % %In their experimental results they
% % % % % % % % % % % % % % %assess the effectiveness of this distribution in a Cholesky
% % % % % % % % % % % % % % %factorization that relies on a cyclic distribution of the rank-k
% % % % % % % % % % % % % % %updates over the layers of a 3D logical processes grid.
% % % % % % % % % % % % % % Their algorithm was
% % % % % % % % % % % % % % implemented in the Chameleon library using a STF model where
% % % % % % % % % % % % % % the reduction across layers
% % % % % % % % % % % % % % is manually implemented through explicit data copies and tasks, where
% % % % % % % % % % % % % % the mapping of tasks is bound to the data distribution and where no
% % % % % % % % % % % % % % collective communications (i.e., broadcast) are used.

% The features of the extended STF model presented in
% Section~\ref{sec:stf-x-features} allows to easily implement this
% approach.

% When dealing with factorization, the trailing submatrix update phase benefits
% from features presented in Section~\ref{sec:stf-x-features}: because
% Schur complements updates over the trailing submatrix are commutative and
% associative they can be computed over different layers. Such a commutativity can
% be leveraged through a reduction operation that was presented in
% Chapter~\ref{sec:stf-matrix-multiply} in the case of matrix-matrix
% multiplication.

% In their work, \citeauthor{b.d.e.l.v:22} proposed to leverage symmetric layouts
% including in the case of 3D algorithms~\cite{b.d.e.l.v:22}. To support their claims, they
% implemented a 3D Cholesky factorization as a proof of concept inside the
% Chameleon library. Their implementation does not rely on the extended STF
% programming model but rather the baseline model presented in
% Section~\ref{sec:baseline-stf-model}. As a result the distributed memory
% reduction operations are explicitly submitted to the runtime which weigh down
% the expression of their algorithm.

In this work we take advantage of the features available in the
extended STF model presented by \citeauthor{a.b.g.h.j:23}~\cite{a.b.g.h.j:23}.
Throuh the \stfRKREDUX access mode, we are able to seamlessly describe the chain
of updates that blocks undergo before their assembly across layers.
This access mode allows us to easily derive an STF implementation
of the 3D Cholesky factorization from the 2D classical STF
implementation: it lets the runtime spawns as many copies of the data as
contributors in the reduction scheme with each copy accessed as \stfRW locally
-- tasks accessing the data additionnally commute if the runtime sees fit.
We have adapted the reduce operation that closes the reduction scheme with an alternative all-reduce operation.
This slight extension essentially ensures the reduced data is available 
across contributors of the reduction scheme and amounts to an
\texttt{allredux\_submit} function in the STF programming model.
We reserve the further study of such algorithmic skeletons for future work.
%The resulting code is presented in
%Figure~\ref{fig:stf_potrf.3D}.
The rank executing the update of the
block $A_{ij}$ at the $l^{\text{th}}$ iteration of the factorization
can be determined through a mapping function \texttt{map}. The
\texttt{map} function takes the current iteration \texttt{i,j,l} as arguments.
It could also be used to state the executing rank
of the other tasks \emph{i.e.} \texttt{trsm} and \texttt{potrf} tasks.
In practice, when $P$ nodes are involved in the
computation and each layer in the logical grid assumes a 2DBC shape. This
amounts to $\texttt{map(i,j,l)} = q*(i\%p) + j\%q + \frac{P}{h}*(l\%h)$ which
evenly balances the computational load related to updates, where $h$
is the number of layers.

%\begin{figure}
%\begin{algorithmic}[h]
%  \FOR{$l = 1\dots m$}
%    \STATE \stfinsert(\potrf, $A_{ll}$:\textcolor{myred}{\stfRW},
%		   map(l,l,0):\stfONRANK)\;
%    \FOR{$i = l+1\dots m$}
%      \STATE \stfinsert(\trsm, $A_{ll}$:\textcolor{myred}{\stfR};
%		    $A_{il}$:\textcolor{myred}{\stfRW},
%		    map(i,l,0):\stfONRANK)\;
%    \ENDFOR
%    \FOR{$i = l+1\dots m$}
%      \FOR{$j= i\dots m$}
%	\STATE rank $\gets$ map(i,j,l)\label{code:stf_potrf.3D.1}\;
%	\STATE op $\gets$ \textbf{if} $i = j$ \textbf{then} \syrk \textbf{else} \gemm \;
%        \STATE \stfinsert(op, $A_{il}$\textcolor{myred}{:R}, %
%			       	    $A_{jl}^\top$:\textcolor{myred}{\stfR}, %
%			            $A_{ij}$:\textcolor{myred}{\stfRKREDUX},
%				    rank:\stfONRANK)\;
%      \ENDFOR
%    \ENDFOR
%  \ENDFOR
%\end{algorithmic}
%  \caption{STF-3D POTRF.}
%  \label{fig:stf_potrf.3D}
%\end{figure}

\subsubsection{Replicating diagonal block factorization}
\label{sec:repl.solv.chol.repl}

%A more efficient but complex 3D Cholesky algorithm is proposed
%by~\citeauthor{s.d:11}~\cite{s.d:11}.
%This algorithm, not only distributes rank-k updates of the trailing
%submatrix across the layers of the 3D logical processes grid, but also the
%\trsm operations. Note that these operations use the diagonal
%block after it has been factorized through a \potrf operation;
%in order to reduce the cost of retrieving this diagonal block, this
%algorithm replicates \potrf on every layer of the ranks
%grid. Finally, prior to being factorized, the diagonal block must be
%assembled because its contributions are spread over
%multiple layers; this can either be achieved through a reduce followed
%by a broadcast or, more efficiently, through an allreduce. Therefore,
%this algorithm can be efficiently implemented using the novel features
%of the STF model that we introduced in Section~\ref{sec:repl}, namely, replicated
%data output and allreduce.

% The first design choice to significantly impact the expression of the algorithm
% is the replication of diagonal blocks' factorization proposed
% by~\citeauthor{s.d:11}~\cite{s.d:11}. Details on the algorithm are found in
% Section~\ref{sec:back.repl.direct}.
%:
%briefly, the objective of the replication is to better parallelize \texttt{trsm}
%tasks by replicating \texttt{potrf} ones across layers. If every block-column/row is
%distributed across layers then broadcasts inside the block-column/row may
%leverage the multiple copies of the factorized diagonal block.
% The authors designed factorization algorithms that require to replicate the
% factorization of each diagonal block across layers. We have incorporated tools
% inside the STF programming model to help with replicating data modification in
% Section~\ref{sec:repl.runtime}.
%(see Section~\ref{sec:back.repl.direct} for further details).
%This extension of the model is instrumental to the expression provided
%in Figure~\ref{alg:stf_potrf.repl}.

An STF implementation of \citeauthor{s.d:11}'s Cholesky
decomposition~\cite{s.d:11}
is presented in Figure~\ref{alg:stf_potrf.repl}.
The actual replication is
presented in Line~\ref{code:stf_potrf.repl.1} using the
\stfinserts wrapper function, which can be used because the
factorization of the diagonal block is replicated through identical
\potrf tasks. Once a diagonal block is factorized, it should
be broadcast to proceed with the solve of the off-diagonal blocks:
ranks that own such a block should retrieve the factorized diagonal
block from a rank that lie on the same layer. This can be declared
through the \texttt{set\_alternative\_source} method (see
Line~\ref{code:stf_potrf.repl.2}).  The rest of the code is
unchanged. The mapping can be set as  $\texttt{map(i,j,l)} = q*(i\%p + j\%q) +
((\frac{m}{L}\frac{i}{L}+\frac{j}{L})\%h)*pq$ where $L=max(p,q)$.

\begin{figure}
\begin{algorithmic}[h]
  \FOR{$l = 1\dots m$}
    \STATE \texttt{\color{myblu}allredux\_submit}($A_{ll}$)\;
    \STATE ranks\_on\_aisle $\gets$ map(l,l,:)\;
    \STATE \textcolor{myblu}{\stfinserts}(ranks\_on\_aisle,\potrf,$A_{ll}$:\textcolor{myred}{\stfRW})\label{code:stf_potrf.repl.1}\;
    \FOR{$i = 1\dots h$}
	    \STATE ranks\_on\_level $\gets$ map(:,:,i)\;
	    \STATE \texttt{\color{myblu}{set\_alternative\_source}}($A_{ll}$, map(l,l,i),ranks\_on\_level)\label{code:stf_potrf.repl.2}\;
    \ENDFOR
    \FOR{$i = l+1\dots m$}
      \STATE \stfinsert(\trsm, $A_{ll}:$\textcolor{myred}{\stfR};
			$A_{il}:$\textcolor{myred}{\stfRW},
			map(i,l,$\frac{i}{\text{max}(p,q)}$):\stfONRANK);
    \ENDFOR
    \FOR{$i = l+1\dots m$}
      \FOR{$j= i\dots m$}
	\STATE rank $\gets$ map(i,j,l)\;
	\STATE op $\gets$ \textbf{if} $i = j$ \textbf{then} \syrk \textbf{else} \gemm \;
        \STATE \stfinsert(op, $A_{il}$:\textcolor{myred}{\stfR}, %
			       	    $A_{jl}^\top$:\textcolor{myred}{\stfR}, %
			            $A_{ij}$:\textcolor{myred}{\stfRKREDUX},
				    rank:\stfONRANK);
      \ENDFOR
    \ENDFOR
  \ENDFOR
\end{algorithmic}
  \caption{STF-3D with diagonal computation replication POTRF.}
  \label{alg:stf_potrf.repl}
\end{figure}

\subsubsection{Comparing the algorithmic variants}
\label{sec:repl.allreduce.exp}

%Several algorithmic variants are now available for benchmarking. For
%all the 3D variants, the matrix $A$ is stored such that it is conforming
%to the mapping of tasks. One way to design such a conforming
%distribution is to start with a generic 2DBC layout of size
%$p \times q$ where $p*q=\sfrac{P}{h}$. This layout matches with the
%logical grid of the bottommost layer. Based on this initial
%distribution, matrix $A$ can be redistributed to the existing $h$
%layers to better match the computational pattern of 3D
%algorithms. Indeed, it is possible to assign a layer to subsets of
%$p \times q$ blocks of the matrix $A$. This assignment can be used as
%an offset from the initial layout. A round-robin procedure, depicted
%in Figure~\ref{fig:repl.3Ddist.rr} for $p=q=2$ and $h=3$, can be
%implemented to make this assignment.
%%This procedure can adapt to 2DBC
%%layouts but also symmetric layouts described in
%%Part~\ref{part:symm.ops}.
%For the Cholesky factorization, this means
%$h*q$ different ranks are involved in the computation of \trsm
%tasks which is suitable to benefit from advanced scalable
%designs.

Three distinct algorithms can be benchmarked using the
extended STF programming model:
\begin{itemize}
	\item \textbf{2D} This is the classical 2D Cholesky factorization
		implementation in STF.
	\item \textbf{Baseline}
		%This corresponds to the 3D Figure~\ref{fig:stf_potrf.3D}.
		For this algorithm, the input
		matrix $A$ is distributed such that the $l^{th}$ column (if
		$A$'s upper half is allocated) is stored over the $l\%h^{th}$
		layer.
		%With an underlying 2DBC distribution, we set
		%$\texttt{rank}(A_{ij}) = q*(i\%p + j\%q) + (j\%h)*pq$.
	\item \textbf{Repl} This corresponds to the 3D
		Figure~\ref{alg:stf_potrf.repl}. For this algorithm, the
		input matrix $A$ is stored as presented in
		Figure~\ref{fig:repl.3Ddist.rr}.
		%With an underlying 2DBC
		%distribution, we set $\texttt{rank}(A_{ij}) = q*(i\%p + j\%q) +
		%((\frac{m}{L}\frac{i}{L}+\frac{j}{L})\%h)*pq$ where $L=max(p,q)$.
%	\item \textbf{Repl-Part} This corresponds to the 3D
%		Figure~\ref{alg:stf_potrf.part} with $H=h$. For this algorithm, the
%		input matrix $A$ is stored the same way as \textbf{Repl}
%		algorithm.
%	\begin{itemize}
%	\item \textbf{\`a la Kwasniewski-1D} This corresponds to
%		Figure~\ref{alg:stf_potrf.part}. The input matrix $A$ is
%		stored in a 1DBC way.
%	\end{itemize}
\end{itemize}

\begin{figure}
  \centering
  \begin{subfigure}[b]{0.45\columnwidth}
    \centering
    \begin{tikzpicture}[semithick,scale=0.4]
      %\draw[fill=white!80!purple] (0,7) rectangle +(1,1);
      %\draw[fill=white!60!purple] (0,6) rectangle +(1,1);
      \draw[fill=white!80!red   ] (0,5) rectangle +(1,1);
      \draw[fill=white!60!red   ] (0,4) rectangle +(1,1);
      \draw[fill=white!80!green ] (0,3) rectangle +(1,1);
      \draw[fill=white!60!green ] (0,2) rectangle +(1,1);
      \draw[fill=white!80!purple] (0,1) rectangle +(1,1);
      \draw[fill=white!60!purple] (0,0) rectangle +(1,1);
      %\draw[fill=white!40!purple] (1,7) rectangle +(1,1);
      %\draw[fill=white!20!purple] (1,6) rectangle +(1,1);
      \draw[fill=white!40!red   ] (1,5) rectangle +(1,1);
      \draw[fill=white!20!red   ] (1,4) rectangle +(1,1);
      \draw[fill=white!40!green ] (1,3) rectangle +(1,1);
      \draw[fill=white!20!green ] (1,2) rectangle +(1,1);
      \draw[fill=white!40!purple] (1,1) rectangle +(1,1);
      \draw[fill=white!20!purple] (1,0) rectangle +(1,1);
      %\draw[fill=white!80!red   ] (2,7) rectangle +(1,1);
      %\draw[fill=white!60!red   ] (2,6) rectangle +(1,1);
      \draw[fill=white!80!green ] (2,5) rectangle +(1,1);
      \draw[fill=white!60!green ] (2,4) rectangle +(1,1);
      \draw[fill=white!80!purple] (2,3) rectangle +(1,1);
      \draw[fill=white!60!purple] (2,2) rectangle +(1,1);
      \draw[fill=white!80!red   ] (2,1) rectangle +(1,1);
      \draw[fill=white!60!red   ] (2,0) rectangle +(1,1);
      %\draw[fill=white!40!red   ] (3,7) rectangle +(1,1);
      %\draw[fill=white!20!red   ] (3,6) rectangle +(1,1);
      \draw[fill=white!40!green ] (3,5) rectangle +(1,1);
      \draw[fill=white!20!green ] (3,4) rectangle +(1,1);
      \draw[fill=white!40!purple] (3,3) rectangle +(1,1);
      \draw[fill=white!20!purple] (3,2) rectangle +(1,1);
      \draw[fill=white!40!red   ] (3,1) rectangle +(1,1);
      \draw[fill=white!20!red   ] (3,0) rectangle +(1,1);
      %\draw[fill=white!80!green ] (4,7) rectangle +(1,1);
      %\draw[fill=white!60!green ] (4,6) rectangle +(1,1);
      \draw[fill=white!80!purple] (4,5) rectangle +(1,1);
      \draw[fill=white!60!purple] (4,4) rectangle +(1,1);
      \draw[fill=white!80!red   ] (4,3) rectangle +(1,1);
      \draw[fill=white!60!red   ] (4,2) rectangle +(1,1);
      \draw[fill=white!80!green ] (4,1) rectangle +(1,1);
      \draw[fill=white!60!green ] (4,0) rectangle +(1,1);
      %\draw[fill=white!40!green ] (5,7) rectangle +(1,1);
      %\draw[fill=white!20!green ] (5,6) rectangle +(1,1);
      \draw[fill=white!40!purple] (5,5) rectangle +(1,1);
      \draw[fill=white!20!purple] (5,4) rectangle +(1,1);
      \draw[fill=white!40!red   ] (5,3) rectangle +(1,1);
      \draw[fill=white!20!red   ] (5,2) rectangle +(1,1);
      \draw[fill=white!40!green ] (5,1) rectangle +(1,1);
      \draw[fill=white!20!green ] (5,0) rectangle +(1,1);
      %\draw[fill=white!80!purple] (6,7) rectangle +(1,1);
      %\draw[fill=white!60!purple] (6,6) rectangle +(1,1);
      %\draw[fill=white!80!red   ] (6,5) rectangle +(1,1);
      %\draw[fill=white!60!red   ] (6,4) rectangle +(1,1);
      %\draw[fill=white!80!green ] (6,3) rectangle +(1,1);
      %\draw[fill=white!60!green ] (6,2) rectangle +(1,1);
      %\draw[fill=white!80!purple] (6,1) rectangle +(1,1);
      %\draw[fill=white!60!purple] (6,0) rectangle +(1,1);
      %\draw[fill=white!40!purple] (7,7) rectangle +(1,1);
      %\draw[fill=white!20!purple] (7,6) rectangle +(1,1);
      %\draw[fill=white!40!red   ] (7,5) rectangle +(1,1);
      %\draw[fill=white!20!red   ] (7,4) rectangle +(1,1);
      %\draw[fill=white!40!green ] (7,3) rectangle +(1,1);
      %\draw[fill=white!20!green ] (7,2) rectangle +(1,1);
      %\draw[fill=white!40!purple] (7,1) rectangle +(1,1);
      %\draw[fill=white!20!purple] (7,0) rectangle +(1,1);

      \draw[step=1.0,black,thin] (0,0) grid +(6,6);
    \end{tikzpicture}
  \end{subfigure}
  \begin{subfigure}[b]{0.45\columnwidth}
    \centering
    \begin{tikzpicture}[semithick,scale=0.4]
      %\draw[fill=white!80!purple] (0,7) rectangle +(1,1);
      %\draw[fill=gray] (0,6) rectangle +(1,1);
      %\draw[fill=gray] (0,5) rectangle +(1,1);
      %\draw[fill=gray] (0,4) rectangle +(1,1);
      %\draw[fill=gray] (0,3) rectangle +(1,1);
      %\draw[fill=gray] (0,2) rectangle +(1,1);
      %\draw[fill=gray] (0,1) rectangle +(1,1);
      %\draw[fill=gray] (0,0) rectangle +(1,1);
      %\draw[fill=white!40!purple] (1,7) rectangle +(1,1);
      %\draw[fill=white!20!purple] (1,6) rectangle +(1,1);
      %\draw[fill=gray] (1,5) rectangle +(1,1);
      %\draw[fill=gray] (1,4) rectangle +(1,1);
      %\draw[fill=gray] (1,3) rectangle +(1,1);
      %\draw[fill=gray] (1,2) rectangle +(1,1);
      %\draw[fill=gray] (1,1) rectangle +(1,1);
      %\draw[fill=gray] (1,0) rectangle +(1,1);
      %\draw[fill=white!80!red   ] (2,7) rectangle +(1,1);
      %\draw[fill=white!60!red   ] (2,6) rectangle +(1,1);
      \draw[fill=white!80!green ] (2,5) rectangle +(1,1);
      \draw[fill=gray] (2,4) rectangle +(1,1);
      \draw[fill=gray] (2,3) rectangle +(1,1);
      \draw[fill=gray] (2,2) rectangle +(1,1);
      \draw[fill=gray] (2,1) rectangle +(1,1);
      \draw[fill=gray] (2,0) rectangle +(1,1);
      %\draw[fill=white!40!red   ] (3,7) rectangle +(1,1);
      %\draw[fill=white!20!red   ] (3,6) rectangle +(1,1);
      \draw[fill=white!40!green ] (3,5) rectangle +(1,1);
      \draw[fill=white!20!green ] (3,4) rectangle +(1,1);
      \draw[fill=gray] (3,3) rectangle +(1,1);
      \draw[fill=gray] (3,2) rectangle +(1,1);
      \draw[fill=gray] (3,1) rectangle +(1,1);
      \draw[fill=gray] (3,0) rectangle +(1,1);
      %\draw[fill=white!80!green ] (4,7) rectangle +(1,1);
      %\draw[fill=white!60!green ] (4,6) rectangle +(1,1);
      \draw[fill=white!80!purple] (4,5) rectangle +(1,1);
      \draw[fill=white!60!purple] (4,4) rectangle +(1,1);
      \draw[fill=white!80!red   ] (4,3) rectangle +(1,1);
      \draw[fill=gray] (4,2) rectangle +(1,1);
      \draw[fill=gray] (4,1) rectangle +(1,1);
      \draw[fill=gray] (4,0) rectangle +(1,1);
      %\draw[fill=white!40!green ] (5,7) rectangle +(1,1);
      %\draw[fill=white!20!green ] (5,6) rectangle +(1,1);
      \draw[fill=white!40!purple] (5,5) rectangle +(1,1);
      \draw[fill=white!20!purple] (5,4) rectangle +(1,1);
      \draw[fill=white!40!red   ] (5,3) rectangle +(1,1);
      \draw[fill=white!20!red   ] (5,2) rectangle +(1,1);
      \draw[fill=gray] (5,1) rectangle +(1,1);
      \draw[fill=gray] (5,0) rectangle +(1,1);
      %\draw[fill=white!80!purple] (6,7) rectangle +(1,1);
      %\draw[fill=white!60!purple] (6,6) rectangle +(1,1);
      \draw[fill=white!80!red   ] (6,5) rectangle +(1,1);
      \draw[fill=white!60!red   ] (6,4) rectangle +(1,1);
      \draw[fill=white!80!green ] (6,3) rectangle +(1,1);
      \draw[fill=white!60!green ] (6,2) rectangle +(1,1);
      \draw[fill=white!80!purple] (6,1) rectangle +(1,1);
      \draw[fill=gray] (6,0) rectangle +(1,1);
      %\draw[fill=white!40!purple] (7,7) rectangle +(1,1);
      %\draw[fill=white!20!purple] (7,6) rectangle +(1,1);
      \draw[fill=white!40!red   ] (7,5) rectangle +(1,1);
      \draw[fill=white!20!red   ] (7,4) rectangle +(1,1);
      \draw[fill=white!40!green ] (7,3) rectangle +(1,1);
      \draw[fill=white!20!green ] (7,2) rectangle +(1,1);
      \draw[fill=white!40!purple] (7,1) rectangle +(1,1);
      \draw[fill=white!20!purple] (7,0) rectangle +(1,1);

%      \draw[step=1.0,black,thin] (0,0) grid +(4,4);% 6,6);
    \end{tikzpicture}
  \end{subfigure}
  \caption[3D distributions with ``large'' blocks distributed in a
  round-robin way.]{3D distributions with ``large'' blocks distributed
    in a round-robin way. One color corresponds to one rank. The three
    color shades (purple, red, green) each correspond to a layer.}
  \label{fig:repl.3Ddist.rr}
\end{figure}

%\paragraph{Communication Volume}

%\begin{figure}
%	\centering
%	\includegraphics[width=\columnwidth]{{figures/bench_potrf-comms.low}.pdf}
%	\caption{\label{fig:cholesky/expe.comms.low} Communication volume for low number
%of nodes.}
%\end{figure}

The first evaluation that can be made is the improvement in communication volume
brought by 3D algorithms.
From Figure~\ref{fig:potrf.comms}, it is clear that the 3D algorithms reduce the
communication volume with respect to the 2D standard algorithm. In the present experiment,
64 Skylake computing nodes are used. For the 2D algorithm, they are arranged in
an $8 \times 8$ logical grid whereas for the 3D algorithm they are arranged in a
$4 \times 4 \times 4$ logical grid.

%\colorbox{myblu}{
%In a 3D grid of size $p \times q \times h$,
%the communication volume $V$ for a Baseline 3D Cholesky factorization of a $m \times m$
%matrix arranged in a block-cyclic $p \times q \times h$ layout can be computed as
%
%\[
%\begin{array}{cccl}
%	V
%	& =
%	& \sum_{i=1}^{m} \Bigl(
%	& \underbrace{(p-1)}_{\substack{\text{send the result}\\\text{of \potrf}}} + \\
%	&&&\underbrace{(m-i)(p-1+q-1)}_{\substack{\text{send the
%	result}\\\text{of \trsm}}} \Bigl) +\\
%	&&&\underbrace{\frac{m(m+1)}{2}(h-1)}_{\substack{\text{assemble the
%result}\\\text{of updates}}}\Bigr)\\
%	& \sim & (p+q+h-3)\frac{m^2}{2}&\\
%\end{array}
%\]
%}

The increase from 3D to 2D algorithms in the presented figure matches we what
can be expected theoretically between the two algorithmic variants. We do
not report the difference in communication volume across all the 3D variants
because it is barely measurable.
%First,
Parallelizing the \trsm tasks only
affects the communication volume corresponding to sending the result of
\potrf tasks which is of the first order in $m$ and thus negligible.
%Second,
%partitioning does not alter the communication volume at all: $H$ slices of $b
%\times \sfrac{b}{H}$ elements weigh as much as one slice of $b \times b$ elements.

\begin{figure}
	\centering
	\includegraphics[width=0.7\columnwidth]{{figures/cholesky.comms}.pdf}
	\caption[Communication volume of Cholesky factorization.]
	{Communication volume of Cholesky factorization with 64 Skylake
	computing nodes. Matrix of increasing sizes are used.}
	\label{fig:potrf.comms}
\end{figure}

%Performance is measured six times per configuration to obtain a
%reliable median that we report.

% Figure~\ref{fig:potrf.scalability.qrm} compares the scalability of the different
% variants implemented through the STF programming model. For these results, one
% MPI thread is created per computing node. Block sizes 256, 512 and 1024 are
% used to explore the tradeoff between arithmetic efficiency and task granularity.
% Our STF implementation relies on efficient MKL BLAS sequential kernels provided by
% the supercomputing facility. The 3D variants use $h=2$ or $h=4$: the best of the
% two configuration is reported.
% The 3D variants however obtain results that are occasionally significantly
% improving the performance of the 2D variant.
% %this is true of both our STF implementation as well as the CONFCHOX library.
% This difference is rather unexpected because Figure~\ref{fig:potrf.comms} shows
% 3D algorithms consistently perform fewer communications. The most sensible
% interpretation of these results is that communications and computation are
% well overlapped most of the time and minimizing communication does not
% systematically yield more performance.
% We can observe that the \textbf{Repl} variant obtains the best results on 128
% nodes for $m = 98,304$ and the \textbf{Baseline} one on 256 nodes for
% $m=163,840$. Such cases seem to fall
% in a ``sweet spot'' where communications are costly enough while proving
% difficult to
% parallelize for 2D algorithms. For the smallest problem, strong scalability is
% difficult to maintain even for 3D algorithms as the amount of work is relatively short.
% In larger problems, the overhead that may come with advanced
% mechanisms -- such as the overhead of replicated computation -- is larger than what
% the overlap of computation and communication can absorb. %In the case of the
% %STF code, it is remarkable that the most advanced design \textbf{Repl+Part}
% %never obtains the best results out of the 3D variants.

% Figure~\ref{fig:potrf.scalability} compares the best of the 2D and 3D
% STF approaches with several state-of-the-art libraries: ScaLAPACK, its
% successor SLATE and Elemental have already been presented in
% Section~\ref{sec:experiments}. CONFCHOX is included in the comparison:
% it is the library from \citeauthor{k.k.b.z:21}\cite{k.k.b.z:21}
% available online which provides an algorithm similar to
% \textbf{Repl+Part}~\footnote{CONFCHOX \texttt{git} repository:
%   \url{https://github.com/eth-cscs/conflux}}. This library relies on
% OpenMP to orchestrate multiple threads across cores as well as MPI to
% exchange messages. In this sense, CONFCHOX is implemented with a
% programming model that is close to SLATE. For CONFCHOX
% we have tested block sizes 256, 512 and 1024 and relied on
% the previously mentioned sequential BLAS kernels. Two MPI ranks are
% spawned per computing node as it proved efficient. One thread
% is spawned per core. Elemental and Slate follow the same mapping of threads.
% Elemental, CONFCHOX and Slate rely on OpenMP
% for thread orchestration while ScaLAPACK relies on MKL
% multithreaded BLAS to busy all cores. We have found that larger block sizes were
% beneficial in this multithreaded case (1024, 2048 and 4096). To
% simplify the reading of the graph, block sizes are not denoted by
% their dimension but qualified by ``Small'', ``Medium'', or ``Large''.
% For each variant in each library, each block size and each problem
% is run four times. We report the median performance of the best block size.
% Elemental failed to run for $m=215,040$ with $P=16$ when allocating the matrix.
% The dimensions of the logical grid of ranks have been chosen to be as square as
% possible as to minimize communications \emph{i.e.} $p \sim q$.
% For CONFCHOX, $h=2$ and $h=4$
% have been tested and we report the best median for any configuration.
% From this figure, we can observe that modern libraries are improving over
% ScaLAPACK which is expected because they rely on asynchronous MPI calls to
% transfer data. The observations that 3D algorithms perform relatively poorly
% remains. Notably the CONFCHOX library performs badly on 128 and 256 nodes which
% is unexpected as it gets remarkable performance on 16, 32 and 64 nodes. We have
% not explored this behavior further.

For the three variants, we have explored three problem sizes which are
relatively small. This choice aims at stressing the capabilities of the
implementation we benchmark to showcase their respective strong scalability.
To maintain fair
communications volume, the underlying distribution is systematically 2DBC
adapted to the 3D logical grid as presented in Figure~\ref{fig:repl.3Ddist.rr}.
Experiments were conducted on platform Skylake described in
Section~\ref{sec:repl.solv.stencil.expe}.
To ensure fairness of comparisons and adapt to
different threads configuration, we have tested three block sizes (256, 512,
1024) that ensure BLAS efficiency.
Figure~\ref{fig:potrf.perfs} compares our STF approaches with the
state-of-the-art CONFCHOX library from \citeauthor{k.k.b.z:21}\cite{k.k.b.z:21}.
This library implements a more sophisticated algorithm that slices the
results of \texttt{trsm} which is fed to subsequent updates.
This library relies on
OpenMP to orchestrate multiple threads across cores as well as MPI to
exchange messages. Both one MPI per node and two MPI pre node configurations
have been tested and we report the best configuration as has been autotuned by
the library given the fixed block sizes. In this graph we report the median
performance attained by each algorithm. This graph allow us to observe the
relative superiority of the STF model to scale to 256 nodes. For $m=32,768$,
ConfCHOX
performance is notably better than all STF variants over less than 32 nodes;
STF variants however get slight improvements as additional compute nodes are
added.
The most
advanced STF variant scales up to 196 nodes before dropping in performance.
On the two remaining configurations, while ConfCHOX obtains respectable
scalability up to 128 nodes it fails to scale beyond this point.
Simpler STF variants prove scalable up to 256 nodes. As the simplest 2D
algorithm scales well, we claim that the improvement in
communication volume from the 3D algorithms does not visibly translate into
performance improvement in the settings we have explored. While our
advanced implementations admittedly fail to prove the most scalable, they remain
operational and competitive.

\begin{figure}
	\centering
	\includegraphics[width=\columnwidth]{{figures/cholesky.perfs}.pdf}
	\caption[Performance of Cholesky factorization.]
	{Median performance scalability of Cholesky factorization.}
	\label{fig:potrf.perfs}
\end{figure}

% We are confident in the capacity of our own implementation to perform correctly:
% our 3D algorithms communicate less as expected. However, 3D algorithms have been designed
% on entirely different machines with entirely different assumptions from the one
% that match with modern implementations. It can be noted that the computing nodes on
% Platform~\ref{exp:skylake} contain more cores and deliver more computing power
% than the ones used by \citeauthor{s.d:11} or \citeauthor{k.k.b.z:21}.
% Moreover 3D algorithms often assume that
% communications are fully synchronous and each computation and communication
% steps of the routine are clearly defined. In all the library except ScaLAPACK this
% hypothesis is not verified: they all leverage asynchronous communications. Our
% implementation moreover benefits from the fine-grain parallelism allowed by the
% StarPU runtime system. Consequently the performance benefit of decreasing the
% communication volume may not be as stark because asynchronous communications
% overlap computations very well on modern machines.
%
% %\improvement[noline]{abdou: phrase a enlever, ca vend les nouvelles approches
% %avec du vent}{
% %While
% %our implementation is correct, it is entirely possible that modern
% %supercomputers require 3D algorithms only when they are equipped with powerful PUs
% %(whether recent CPUs or GPUs) or when even more computing nodes are used. These
% %hypotheses remain to be explored in future work.
% %\todoaj{je suis d'accord mais j'ai l'impression qu'il y a quelque chose d'un peu
% %positif a dire (ramener a des future works ca me semble positif)}
% %}
%
% \begin{figure}
% 	\centering
% 	\includegraphics[width=\columnwidth]{{figures/bench_potrf.scalability.qrm}.pdf}
% 	\caption[Strong scalability \POTRF STF benchmark]
% 	{Benchmarking all 3D variants using the STF model in a strong
% 	scalability settings for some problem sizes of increasing dimension.}
% 	\label{fig:potrf.scalability.qrm}
% \end{figure}
%
% \begin{figure}
% 	\centering
% 	\includegraphics[width=\columnwidth]{{figures/bench_potrf.scalability}.pdf}
% 	\caption[Strong scalability \POTRF libraries benchmark]
% 	{Benchmarking reference
% 	libraries and STF model in a strong scalability settings for some
% 	problem sizes of increasing dimension.}
% 	\label{fig:potrf.scalability}
% \end{figure}

%\paragraph{Performance}
%
%%\begin{figure}
%%	\centering
%%	\includegraphics[width=\columnwidth]{{figures/bench_potrf.low}.pdf}
%%	\caption{\label{fig:cholesky/expe.comms.mid} Performance of STF model for low
%%number of nodes.}
%%\end{figure}
%
%\todoaj{The most advanced design is the worst one.}
%
%\begin{figure}
%	\centering
%	\includegraphics[width=\columnwidth]{{figures/bench_potrf.mid}.pdf}
%	\caption{\label{fig:cholesky/expe.comms.mid} Performance of STF model for mid
%number of nodes.}
%\end{figure}

% useless, we know we need and we use Mcast
%
%\begin{figure}
%	\centering
%	\includegraphics[width=\columnwidth]{{figures/bench_potrf.delegate_or_not.mid.fix}.pdf}
%	\caption{\label{fig:cholesky/expe.comms.mid.fix} Performance of STF model for mid
%number of nodes comparing communication patterns.}
%\end{figure}

% Figure~\ref{fig:potrf.core.gemm} details the performance of a single
% Platform~\ref{exp:skylake} core. The figure evaluates the execution speed of
% multiple \gemm executions with only the median reported. Here, the resulting
% matrix $C$ is always square ($m=n$) but the update size $k$ is increased from 64 up
% to the size of $C$. The graph shows that peak performance is attained when $C$
% is at least of dimension $512$. It also shows that the update size should
% be large to maintain peak performance: with $C$ of dimension $512$, if $k=\sfrac{512}{4}=128$ then the
% execution speed of the kernel is decreased by $10\%$. While this decrease in
% performance can seem negligible, it should be pointed out that because
% \gemm tasks make up the largest portion of tasks a diminution in
% execution speed may become noticeable. Such a diminution of the kernel speed may
% explain why the \textbf{Repl+Part} variant in
% Figure~\ref{fig:potrf.scalability.qrm} is
% underperforming all the other variants implemented in the STF model in the
% majority of the configurations. With the largest block size of $1024$ however, the
% \textbf{Repl+Part} variant obtained the best results for $m=215,040$ using
% $P=128$ and $P=256$ nodes with 117 TFlop/s (+42\% over 2D) and 143.3 TFlop/s
% (+19\% over next best 3D variant \textbf{Repl}) respectively. These results, not
% reported in the figure because a smaller block size is more beneficial, hint
% at the potential interest of partitioning the updates across layers that could
% be explored in future work.
% %     m   P remap reduxtree  p  q s h algo extra   med_flops    med_flops
% %215040 128     D           16  8   1    D     X 8.235126e+13 82.35 10+12
% %215040 128     M            8  8   2    D     X 8.785106e+13 87.85 10+12
% %215040 128     S            8  8   2    Z     R 1.199160e+14 119.9 10+12
% %215040 128     S            8  8   2    Z     Z 1.170568e+14 117.0 10+12
% %215040 256     D           16 16   1    D     X 8.719841e+13 87.19 10+12
% %215040 256     M            8  8   4    D     X 1.111940e+14 111.1 10+12
% %215040 256     S            8  8   4    Z     R 1.203736e+14 120.3 10+12
% %215040 256     S            8  8   4    Z     Z 1.433758e+14 143.3 10+12
%
% \begin{figure}
% 	\centering
% %	\begin{subfigure}[b]{0.45\columnwidth}
% 	\includegraphics[width=0.8\columnwidth]{{figures/bench_potrf.core.gemm}.pdf}
% 	\caption{Double-precision GEMM single-core performance}
% 	\label{fig:potrf.core.gemm}
% %	\end{subfigure}
% %	\begin{subfigure}[b]{0.45\columnwidth}
% %		\includegraphics[width=\columnwidth]{{figures/bench_potrf.core.potrf}.pdf}
% %		\caption{\label{fig:cholesky/expe.core.gemm} Double-precision POTRF
% %		single-core performance}
% %	\end{subfigure}
% \end{figure}

%\section{Concluding remarks}
%
%In this chapter, two features have been introduced to extend the STF
%programming model further.
%
%The first one introduces an additional data access mode \stfSAME
%that allows replicating data output. This access mode is provided
%to the programmer to declare replicated data modifications across
%ranges of nodes. The use of this access mode has been validated on a
%2D 5-points stencil application by implementing a
%communication-avoiding algorithm. The resulting code is simplified by
%using the access mode -- the programmer does not need to consider
%additional tasks to explicitly manage replicated copies, rather she/he
%just tell the runtime what tasks should be multiplied over which
%ranks. The experimental results assess the effectiveness of this new
%feature as the communication-avoiding variant proves to be more
%scalable than its conventional counterpart, as expected from the
%literature.
%
%The second extension to the programming model is the addition of an allreduce
%operation. We introduced the \texttt{allredux\_submit} method that,
%when called, generates appropriate tasks to compute the allreduce of a
%data that was previously updated by tasks submitted with the
%\stfRKREDUX access mode. More work might be required to make
%this feature completely transparent, for example, through automatic
%tasks generation as in the case of the reduce operation; this
%approach, however, is very little intrusive and preserves the
%readability of the code.
%
%The combination of the two
%extensions with those of Chapter~\ref{sec:stf-matrix-multiply} makes it
%possible to express scalable Cholesky factorization algorithms. Several variants
%of such algorithms exist and four have been considered. Because these variants
%incrementally expand the design of one another, only two routines have actually
%been implemented with parameters guiding their behaviors to target specific
%variants. The first routine covers the \textbf{Baseline} and \textbf{2D} variants.
%The second one covers the remaining variants. While it is technically possible
%to cover all variants within one code, the engineering effort albeit small was
%not deemed necessary. The final expression we have provided demonstrates that the
%STF programming model can provide compact and versatile code assembling key
%designs and concepts from the literature on scalable algorithms.
%% un peu fort ?
%Experiments have shown the STF implementations can be scalable with respect
%to reference implementations, sometimes outperforming them.


%%% Local Variables:
%%% mode: latex
%%% TeX-master: "thesis"
%%% jinx-languages: "en"
%%% End:
